.\"

.\" GLE Tubing & Extrusions Library Documentation 

.\"

.TH gleHelicoid 3GLE "3.6" "GLE" "GLE"

.SH NAME

gleHelicoid - Generalized torus, spiral with circle contour.

.SH SYNTAX

.nf

.LP

void gleHelicoid (gleDouble rToroid,

                  gleDouble up[3],

                  gleDouble startRadius,

                  gleDouble drdTheta,

                  gleDouble startZ,

                  gleDouble dzdTheta,

                  gleDouble startXform[2][3],

                  gleDouble dXformdTheta[2][3],

                  gleDouble startTheta,

                  gleDouble sweepTheta);

.fi

.SH ARGUMENTS

.IP \fIrToroid\fP 1i

circle contour (torus) radius

.IP \fIstartRadius\fP 1i

spiral starts in x-y plane

.IP \fIdrdTheta\fP 1i

change in radius per revolution

.IP \fIstartZ\fP 1i

starting z value

.IP \fIdzdTheta\fP 1i

change in Z per revolution

.IP \fIstartXform\fP 1i

starting contour affine transformation

.IP \fIdXformdTheta\fP 1i

tangent change xform per revolution

.IP \fIstartTheta\fP 1i

start angle in x-y plane

.IP \fIsweepTheta\fP 1i

degrees to spiral around

.SH DESCRIPTION



Generalized Torus. Similar to gleSpiral, except contour is a circle.

Uses gleSpiral to draw.



.SH SEE ALSO

gleSpiral, gleToroid

.SH AUTHOR

Linas Vepstas (linas@fc.net)

